#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long t,m=0,p=0,z=0;
    long long b=0;
    long long c=0;
    cin>>t;
    long long rez[6];
for(int i=0;i<t;i++){
  cin>>b;
  cin>>c;
      long long a[b];
      long long d[c];
  for(int j=0;j<2;j++){
      cin>>a[j];
  }
  m=abs(a[1]-a[0]);
  for(int j=2;j<b;j++){
      cin>>a[j];
      m=__gcd(m,abs(a[j]-a[j-1]));
  }
  z=a[1]%m;
  for(int j=0;j<c;j++){
          cin>>d[j];
          }
  for(int j=0;j<c;j++){
          p=d[j];
          if(p%m==z){rez[i]=0;
          break;
              
          }
  }
   if(p%m!=z){rez[i]=1;
   }
}
for(int i=0;i<t;i++){
    cout<<rez[i]<<endl;
}
return 0;
}